#version 330
uniform vec4 lumPos;
uniform mat4 modelViewMatrix;
in  vec3 vsoNormal;
in  vec3 vsoModPos;
in  vec2 vsoTexCoord;
out vec4 fragColor;

void main(void) {
  const float shininess = 10;
  float diffuse_factor, specular_factor;
  vec4 ambient_color = vec4(0.2, 0, 0, 1);
  vec4 diffuse_color = vec4(1, 0.3, 0.3, 1);
  vec4 specular_color = vec4(1, 1, 0.6, 1);
  vec3 N = normalize(vsoNormal);
  vec3 L = normalize(vsoModPos - lumPos.xyz);
  vec3 R = reflect(L, N);

  diffuse_factor = dot(N, -L);
  diffuse_color *= diffuse_factor;

  specular_factor = pow(clamp(dot(-R, vec3(0, 0, -1)), 0, 1), shininess);
  specular_color *= specular_factor;

  fragColor = ambient_color + diffuse_color + specular_color;
}
